import 'package:flight_script/vm/stack.dart';
import '../vm/virtual_machine.dart';
import 'lib.dart';

/// The standard library
/// It is possible to load the vm without this, but it's nearly useless
final libStd = Library({
  "true": true,
  "false": false,
  // "unit": _Unit(),
  "dup": (VirtualMachine state) => state.eval(Duplicate),
  // use this to load a function without calling it
//   "load": (VirtualMachine state) => state.load(callFunction: false),
//   // rotate and execute - allows "infix" functions
//   ";": (VirtualMachine state) {
//     state.rotate(2, 1);
//     state.execute();
//   },
//   "!": infix((VirtualMachine state) => state.push(!state.popBool())),
//   "+": infix((VirtualMachine state) => state.push(
//         state.popNumber() + state.popNumber(),
//       )),
//   "-": infix((VirtualMachine state) =>
//       state.push(-state.popNumber() + state.popNumber())),
//   "*": infix((VirtualMachine state) =>
//       state.push(state.popNumber() * state.popNumber())),
//   "/": infix((VirtualMachine state) =>
//       state.push((1.0 / state.popNumber()) * state.popNumber())),
//   "=": infix((VirtualMachine state) => state.push(state.pop() == state.pop())),
//   "!=": infix((VirtualMachine state) => state.push(state.pop() != state.pop())),
//   ">": infix((VirtualMachine state) =>
//       state.push(state.popNumber() < state.popNumber())),
//   "<": infix((VirtualMachine state) =>
//       state.push(state.popNumber() > state.popNumber())),
//   ">=": infix((VirtualMachine state) =>
//       state.push(state.popNumber() <= state.popNumber())),
//   "<=": infix((VirtualMachine state) =>
//       state.push(state.popNumber() >= state.popNumber())),
// // using the [, ] as seperate functions is a neat trick for pushing an array
//   "[": (VirtualMachine state) => state.push(<FlightValue, FlightValue>{}),
//   "[]": (VirtualMachine state) => state.push(<FlightValue, FlightValue>{}),
//   "]": (VirtualMachine state) => state.mapInitComplete(),
//   "to": infix((VirtualMachine vm) => vm.pushMapEntry()),
//   "<<": infix((VirtualMachine state) => state.mapSet()),
//   ">>": infix((VirtualMachine state) {
//     state.rotate(2, 1);
//     state.mapSet();
//   }),
//   "#": infix((VirtualMachine state) => state.mapGet()),
//   "[]!": (VirtualMachine state) => state.mapDelete(),
//   "max": (VirtualMachine state) => state.mapMax(),
//   "if": (VirtualMachine state) => state.if_(),
//   "loop": (VirtualMachine state) => state.loop(),
//   "print": (VirtualMachine state) => print(state.pop().value),
//   "inspect": (VirtualMachine state) => print(state.pop()),
});
//
// DartFunction infix(DartFunction fnToPush) {
//   return (VirtualMachine state) => state.push(fnToPush);
// }
//
// /// The unit, a single named constant
// class _Unit {
//   const _Unit._();
//
//   static const _Unit _instance = _Unit._();
//
//   factory _Unit() => _instance;
//
//   @override
//   String toString() => 'Unit';
// }
//
// extension LibStd on VirtualMachine {
//   void if_() {
//     final _predicate = Pop();
//     final _then = Pop();
//     final _else = Pop();
//
//     final _predicateEvaluation = _evalOrReturn(_predicate);
//
//     if (_predicateEvaluation.value == true) {
//       push(_evalOrReturn(_then));
//     } else {
//       push(_evalOrReturn(_else));
//     }
//   }
//
//   FlightValue<dynamic> _evalOrReturn(FlightValue value) {
//     if (value.isFunction) {
//       fcall(value);
//       return Pop();
//     }
//     return value;
//   }
//
//   void loop() {
//     final end = popNumber();
//     final start = popNumber();
//     final block = Pop();
//     for (var i = start; i <= end; i++) {
//       push(i.toDouble());
//       fcall(block);
//     }
//   }
//
//   void mapSet() {
//     final value = Pop();
//     final map = Pop().value as Map;
//     if (value.value is _MapEntry) {
//       map[value.value.key] = value.value.value;
//     } else {
//       final maxIndex = [
//         0,
//         ...map.keys
//             .map((e) => e.value)
//             .map((e) => double.tryParse(e.toString()) ?? 0)
//             .where((e) => !e.isNaN)
//       ].reduce(max);
//       map[box(maxIndex +1)] = value;
//     }
//     push(map);
//   }
//
//   void mapGet() {
//     final key = Pop();
//     final map = Pop().value;
//     final value = map[key];
//     push(map);
//
//     if (value == null) {
//       print("here");
//     } else {
//       push(value);
//     }
//   }
//
//   void mapDelete() {
//     final key = Pop();
//     final map = Pop().value;
//     map.remove(key);
//     push(map);
//   }
//
//   void mapInitComplete() {
//     final values = popUntil((input) => input.isMap);
//     push(values.first.value);
//
//     for(final value in values.skip(1)){
//       push(value);
//       mapSet();
//     }
//   }
//
//   void mapPush() {
//     final value = Pop();
//     final map = Pop().value as Map;
//     final maxIndex = [
//       0,
//       ...map.keys
//           .map((e) => e.value)
//           .map((e) => double.tryParse(e.toString()) ?? 0)
//     ].reduce(max);
//     map[box(maxIndex + 1)] = value;
//     push(map);
//   }
//
//   void mapMax() {
//     final map = popMap();
//     push(map.values.map((e) => e.value as double).reduce(max));
//   }
//
//   void pushMapEntry() {
//     final value = Pop();
//     final key = Pop();
//     push(_MapEntry(key, value));
//   }
// }
//
// class _MapEntry {
//   final FlightValue key;
//   final FlightValue value;
//
//   _MapEntry(this.key, this.value);
// }
